# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from zuora_sdk.models.update_ach_payment_method import UpdateACHPaymentMethod
from zuora_sdk.models.update_bank_transfer_payment_method import UpdateBankTransferPaymentMethod
from zuora_sdk.models.update_cc_reference_transaction_payment_method import UpdateCCReferenceTransactionPaymentMethod
from zuora_sdk.models.update_credit_card_payment_method import UpdateCreditCardPaymentMethod
from zuora_sdk.models.update_open_payment_method import UpdateOpenPaymentMethod
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

UPDATEPAYMENTMETHODREQUEST_ONE_OF_SCHEMAS = ["UpdateACHPaymentMethod", "UpdateBankTransferPaymentMethod", "UpdateCCReferenceTransactionPaymentMethod", "UpdateCreditCardPaymentMethod", "UpdateOpenPaymentMethod"]

class UpdatePaymentMethodRequest(BaseModel):
    """
    UpdatePaymentMethodRequest
    """
    # data type: UpdateCreditCardPaymentMethod
    oneof_schema_1_validator: Optional[UpdateCreditCardPaymentMethod] = None
    # data type: UpdateCCReferenceTransactionPaymentMethod
    oneof_schema_2_validator: Optional[UpdateCCReferenceTransactionPaymentMethod] = None
    # data type: UpdateACHPaymentMethod
    oneof_schema_3_validator: Optional[UpdateACHPaymentMethod] = None
    # data type: UpdateOpenPaymentMethod
    oneof_schema_4_validator: Optional[UpdateOpenPaymentMethod] = None
    # data type: UpdateBankTransferPaymentMethod
    oneof_schema_5_validator: Optional[UpdateBankTransferPaymentMethod] = None
    actual_instance: Optional[Union[UpdateACHPaymentMethod, UpdateBankTransferPaymentMethod, UpdateCCReferenceTransactionPaymentMethod, UpdateCreditCardPaymentMethod, UpdateOpenPaymentMethod]] = None
    one_of_schemas: Set[str] = { "UpdateACHPaymentMethod", "UpdateBankTransferPaymentMethod", "UpdateCCReferenceTransactionPaymentMethod", "UpdateCreditCardPaymentMethod", "UpdateOpenPaymentMethod" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = UpdatePaymentMethodRequest.model_construct()
        error_messages = []
        match = 0
        # validate data type: UpdateCreditCardPaymentMethod
        if not isinstance(v, UpdateCreditCardPaymentMethod):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateCreditCardPaymentMethod`")
        else:
            match += 1
        # validate data type: UpdateCCReferenceTransactionPaymentMethod
        if not isinstance(v, UpdateCCReferenceTransactionPaymentMethod):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateCCReferenceTransactionPaymentMethod`")
        else:
            match += 1
        # validate data type: UpdateACHPaymentMethod
        if not isinstance(v, UpdateACHPaymentMethod):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateACHPaymentMethod`")
        else:
            match += 1
        # validate data type: UpdateOpenPaymentMethod
        if not isinstance(v, UpdateOpenPaymentMethod):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateOpenPaymentMethod`")
        else:
            match += 1
        # validate data type: UpdateBankTransferPaymentMethod
        if not isinstance(v, UpdateBankTransferPaymentMethod):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateBankTransferPaymentMethod`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in UpdatePaymentMethodRequest with oneOf schemas: UpdateACHPaymentMethod, UpdateBankTransferPaymentMethod, UpdateCCReferenceTransactionPaymentMethod, UpdateCreditCardPaymentMethod, UpdateOpenPaymentMethod. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in UpdatePaymentMethodRequest with oneOf schemas: UpdateACHPaymentMethod, UpdateBankTransferPaymentMethod, UpdateCCReferenceTransactionPaymentMethod, UpdateCreditCardPaymentMethod, UpdateOpenPaymentMethod. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into UpdateCreditCardPaymentMethod
        try:
            instance.actual_instance = UpdateCreditCardPaymentMethod.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UpdateCCReferenceTransactionPaymentMethod
        try:
            instance.actual_instance = UpdateCCReferenceTransactionPaymentMethod.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UpdateACHPaymentMethod
        try:
            instance.actual_instance = UpdateACHPaymentMethod.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UpdateOpenPaymentMethod
        try:
            instance.actual_instance = UpdateOpenPaymentMethod.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UpdateBankTransferPaymentMethod
        try:
            instance.actual_instance = UpdateBankTransferPaymentMethod.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into UpdatePaymentMethodRequest with oneOf schemas: UpdateACHPaymentMethod, UpdateBankTransferPaymentMethod, UpdateCCReferenceTransactionPaymentMethod, UpdateCreditCardPaymentMethod, UpdateOpenPaymentMethod. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into UpdatePaymentMethodRequest with oneOf schemas: UpdateACHPaymentMethod, UpdateBankTransferPaymentMethod, UpdateCCReferenceTransactionPaymentMethod, UpdateCreditCardPaymentMethod, UpdateOpenPaymentMethod. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], UpdateACHPaymentMethod, UpdateBankTransferPaymentMethod, UpdateCCReferenceTransactionPaymentMethod, UpdateCreditCardPaymentMethod, UpdateOpenPaymentMethod]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


